/*$
	Written by Balint Seeber (balint@spench.net)
$*/
// dialogAddDir.cpp : implementation file
//

#include "stdafx.h"
#include "CodeCounter.h"
#include "dialogAddDir.h"

// CdialogAddDir dialog

IMPLEMENT_DYNAMIC(CdialogAddDir, CDialog)
CdialogAddDir::CdialogAddDir(CWnd* pParent /*=NULL*/)
	: CDialog(CdialogAddDir::IDD, pParent)
	, m_bRecurseSubDirs(TRUE)
//	, m_strDirectory(_T(""))
{
}

CdialogAddDir::~CdialogAddDir()
{
}

void CdialogAddDir::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK_RECURSESUBDIRS, m_bRecurseSubDirs);
	DDX_Text(pDX, IDC_EDIT_DIRECTORY, m_strDirectory);
}

BEGIN_MESSAGE_MAP(CdialogAddDir, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_BROWSEDIRS, OnBnClickedButtonBrowsedirs)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// CdialogAddDir message handlers

void CdialogAddDir::OnBnClickedButtonBrowsedirs()
{
	BROWSEINFO browseinfo;
	memset(&browseinfo, 0, sizeof(BROWSEINFO));
	browseinfo.hwndOwner = GetSafeHwnd();
	browseinfo.ulFlags = BIF_USENEWUI | BIF_RETURNONLYFSDIRS;
	LPITEMIDLIST pItemIDList = SHBrowseForFolder(&browseinfo);
	if (pItemIDList)
	{
		LPMALLOC pMalloc;
		if (FAILED(SHGetMalloc(&pMalloc)) || (pMalloc == NULL))
		{
			AfxMessageBox("Error: Failed to SHGetMalloc");
			return;
		}
		LPTSTR pStr = m_strDirectory.GetBuffer(MAX_PATH);
		SHGetPathFromIDList(pItemIDList, pStr);
		m_strDirectory.ReleaseBuffer();
		pMalloc->Free(pItemIDList);
		pMalloc->Release();
		UpdateData(FALSE);
	}
}

void CdialogAddDir::OnDestroy()
{
	AfxGetApp()->WriteProfileString(_T("Settings"), _T("LastDirectory"), m_strDirectory);
	AfxGetApp()->WriteProfileInt(_T("Settings"), _T("Recurse"), m_bRecurseSubDirs);

	CDialog::OnDestroy();
}

BOOL CdialogAddDir::OnInitDialog()
{
	m_strDirectory = AfxGetApp()->GetProfileString(_T("Settings"), _T("LastDirectory"), m_strDirectory);
	m_bRecurseSubDirs = AfxGetApp()->GetProfileInt(_T("Settings"), _T("Recurse"), m_bRecurseSubDirs);

	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CdialogAddDir::OnOK()
{
	m_strDirectory.TrimRight(_T("\\"));

	CDialog::OnOK();
}
