/*$
	Written by Balint Seeber (balint@spench.net)
$*/
// dialogMain.cpp : implementation file
//

#include "stdafx.h"
#include "CodeCounter.h"
#include "dialogMain.h"

#include "dialogAddDir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButtonWww();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_WWW, OnBnClickedButtonWww)
END_MESSAGE_MAP()

// CdialogMain dialog

CdialogMain::CdialogMain(CWnd* pParent /*=NULL*/)
	: CDialog(CdialogMain::IDD, pParent)
	, m_strExtensions(_T("*.c;*.cpp;*.h;*.hxx;*.cxx;*.inl"))
	, m_strTotals(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CdialogMain::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_DIRECTORIES, m_cntrlList_Directories);
	DDX_Text(pDX, IDC_EDIT_EXTENSIONS, m_strExtensions);
	DDX_Control(pDX, IDC_LIST_FILES, m_cntrlList_Files);
	DDX_Text(pDX, IDC_STATIC_TOTALS, m_strTotals);
}

void CAboutDlg::OnBnClickedButtonWww()
{
	ShellExecute(GetSafeHwnd(), _T("open"), _T("http://spench.net/"), NULL, NULL, SW_SHOW);
}

BEGIN_MESSAGE_MAP(CdialogMain, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_ADDDIRECTORY, OnBnClickedButtonAdddirectory)
	ON_BN_CLICKED(IDC_BUTTON_COUNT, OnBnClickedButtonCount)
	ON_WM_DESTROY()
	ON_NOTIFY(HDN_ITEMCLICK, 0, OnHdnItemclickListFiles)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_FILES, OnNMDblclkListFiles)
	ON_NOTIFY(LVN_KEYDOWN, IDC_LIST_FILES, OnLvnKeydownListFiles)
END_MESSAGE_MAP()

// CdialogMain message handlers

BOOL CdialogMain::OnInitDialog()
{
	m_strExtensions = AfxGetApp()->GetProfileString(_T("Settings"), _T("Extensions"), m_strExtensions);

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_cntrlList_Files.InsertColumn(0, _T("Relative path"), LVCFMT_RIGHT, 358);
	m_cntrlList_Files.InsertColumn(1, _T("FIXMEs"), LVCFMT_CENTER, 65);
	m_cntrlList_Files.InsertColumn(2, _T("Code"), LVCFMT_CENTER, 65);
	m_cntrlList_Files.InsertColumn(3, _T("Comments"), LVCFMT_CENTER, 65);
	m_cntrlList_Files.InsertColumn(4, _T("Total"), LVCFMT_CENTER, 65);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CdialogMain::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CdialogMain::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CdialogMain::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CdialogMain::OnBnClickedButtonAdddirectory()
{
	CdialogAddDir dialogAddDir;
	if (dialogAddDir.DoModal() == IDOK)
	{
		m_cntrlList_Directories.AddString(dialogAddDir.m_strDirectory);

		if (dialogAddDir.m_bRecurseSubDirs)
			_RecurseDirectories(dialogAddDir.m_strDirectory);

//		UpdateData(FALSE);
	}
}

void CdialogMain::_RecurseDirectories(CString strPath)
{
	CFileFind filefind;
	//strPath.TrimRight(_T("\\"));
	bool bContinue = filefind.FindFile(strPath + _T("\\*.*")) ? true : false;
	while (bContinue)
	{
		bContinue = filefind.FindNextFile() ? true : false;

		if (!filefind.IsDots())
		{
			if (filefind.IsDirectory())
			{
				m_cntrlList_Directories.AddString(filefind.GetFilePath());
				_RecurseDirectories(filefind.GetFilePath());
			}
			else
			{
//				m_iFilesAdded++;
			}
		}
	}

	if (GetLastError() != ERROR_NO_MORE_FILES)
		AfxMessageBox("Error: Failed to FindNextFile");

	filefind.Close();
}

int Tokenise(const CString& str, CStringArray& array, PCSTR token)
{
	if (str.GetLength() == 0)
		return 0;

	CString strBuffer(str);
	strBuffer.TrimLeft(token);
	int iIndex = strBuffer.FindOneOf(token);
	if (iIndex == -1)
		array.Add(str);
	else
	{
		while (iIndex > -1)
		{
			array.Add(strBuffer.Left(iIndex));
			strBuffer = strBuffer.Mid(iIndex + 1);
			strBuffer.TrimLeft(token);
			iIndex = strBuffer.FindOneOf(token);
		}

		if (strBuffer.IsEmpty() == false)
			array.Add(strBuffer);
	}

	return (int)array.GetCount();
}

void CdialogMain::OnBnClickedButtonCount()
{
	UpdateData();

	if (m_cntrlList_Directories.GetCount() == 0)
	{
		AfxMessageBox(_T("Please add some directories first"));
		return;
	}

	CStringArray arrayExtensions;
	if (Tokenise(m_strExtensions, arrayExtensions, _T(";")) == 0)
	{
		AfxMessageBox(_T("Please specify at least one extension first"));
		return;
	}

	m_cntrlList_Files.DeleteAllItems();

	GetDlgItem(IDC_BUTTON_COUNT)->EnableWindow(FALSE);

	int iIndex = 0;
	CString strParentPath;

	iTotalTotal = 0;
	iTotalCode = 0;
	iTotalComments = 0;
	iFiles = 0;
	iTotalFixMes = 0;

	while (iIndex < m_cntrlList_Directories.GetCount())
	{
		m_cntrlList_Directories.SetCurSel(iIndex);

		CString strPath;
		m_cntrlList_Directories.GetText(iIndex, strPath);

		if (iIndex == 0)
			strParentPath = strPath + _T("\\");

		//strPath.TrimRight(_T("\\"));

		for (INT_PTR iCount = 0; iCount < arrayExtensions.GetCount(); iCount++)
		{
			CString strFindPath(strPath);
			strFindPath += _T("\\") + arrayExtensions[iCount];

			CFileFind filefind;
			BOOL bContinue = filefind.FindFile(strFindPath);
			while (bContinue)
			{
				iFiles++;
				bContinue = filefind.FindNextFile();

				CStdioFile file;
				if (file.Open(filefind.GetFilePath(), CFile::modeRead) == FALSE)
				{
					AfxMessageBox(_T("Failed to open:\n\n") + filefind.GetFilePath());
					continue;
				}

				int iFixMes = 0;
				int iTotal = 0;
				int iCode = 0;
				int iComments = 0;
				//bool bInComment = false;

				bool bBlockComment = false;
				bool bLineComment = false;

                CString strBuf;
				while (file.ReadString(strBuf))
				{
					strBuf.TrimLeft();
					strBuf.TrimRight();
					if (strBuf.IsEmpty())
						continue;

					if ((strBuf == _T("{")) || (strBuf == _T("}")))
						continue;

					if (strBuf.Find(_T("FIXME")) > -1)
						iFixMes++;

					iTotal++;

					while (strBuf.IsEmpty() == false)
					{
						UINT iIndexLine = strBuf.Find(_T("//"));
						UINT iIndexBlockStart = strBuf.Find(_T("/*"));
						UINT iIndexBlockEnd = strBuf.Find(_T("*/"));

						if ((iIndexLine < iIndexBlockStart) && (iIndexLine < iIndexBlockEnd))
						{
							if (bBlockComment == false)
							{
								if (iIndexLine > 0)
									iCode++;
								//else
									iComments++;

								break;
							}

							strBuf = strBuf.Mid(iIndexLine + 2);
						}
						else if ((iIndexBlockStart < iIndexLine) && (iIndexBlockStart < iIndexBlockEnd))
						{
							if (bBlockComment == false)
							{
								if (iIndexBlockStart > 0)
									iCode++;
								//else
									iComments++;

								bBlockComment = true;
							}

							strBuf = strBuf.Mid(iIndexBlockStart + 2);
						}
						else if ((iIndexBlockEnd < iIndexLine) && (iIndexBlockEnd < iIndexBlockStart))
						{
							if (bBlockComment)
							{
								bBlockComment = false;
							}

							strBuf = strBuf.Mid(iIndexBlockEnd + 2);
						}
						else
						{
							iCode++;
							break;
						}
					}
				}

				CString strRelativePath(filefind.GetFilePath());
				if (strRelativePath.GetLength() > strParentPath.GetLength())
					strRelativePath = strRelativePath.Mid(strParentPath.GetLength());

				int iItemIndex = m_cntrlList_Files.InsertItem(m_cntrlList_Files.GetItemCount(), strRelativePath);
				m_cntrlList_Files.SetItemData(iItemIndex, iItemIndex);
				strBuf.Format(_T("%i"), iFixMes);
				m_cntrlList_Files.SetItemText(iItemIndex, 1, strBuf);
				strBuf.Format(_T("%i"), iCode);
				m_cntrlList_Files.SetItemText(iItemIndex, 2, strBuf);
				strBuf.Format(_T("%i"), iComments);
				m_cntrlList_Files.SetItemText(iItemIndex, 3, strBuf);
				strBuf.Format(_T("%i"), iTotal);
				m_cntrlList_Files.SetItemText(iItemIndex, 4, strBuf);

				iTotalFixMes += iFixMes;
				iTotalTotal += iTotal;
				iTotalCode += iCode;
				iTotalComments += iComments;

				file.Close();
			}
		}

		iIndex++;
	}

	m_strTotals.Format(_T("Files: %i FIXMEs: %i Code: %i Comments: %i Total: %i"), iFiles, iTotalFixMes, iTotalCode, iTotalComments, iTotalTotal);
	UpdateData(FALSE);

	GetDlgItem(IDC_BUTTON_COUNT)->EnableWindow();
}

void CdialogMain::OnDestroy()
{
	AfxGetApp()->WriteProfileString(_T("Settings"), _T("Extensions"), m_strExtensions);

	CDialog::OnDestroy();
}

static int CALLBACK StringCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CListCtrl* pListCtrl = (CListCtrl*)lParamSort;
	CString    strItem1 = pListCtrl->GetItemText((int)lParam1, 0);
	CString    strItem2 = pListCtrl->GetItemText((int)lParam2, 0);

	return -strcmp(strItem2, strItem1);
}

typedef struct
{
	CListCtrl* pListCtrl;
	int iIndex;
} SORTINFO, *PSORTINFO;

static int CALLBACK IntegerCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	PSORTINFO pSortInfo = (PSORTINFO)lParamSort;
	CListCtrl* pListCtrl = (CListCtrl*)pSortInfo->pListCtrl;
	int i1 = atoi(pListCtrl->GetItemText((int)lParam1, pSortInfo->iIndex));
	int i2 = atoi(pListCtrl->GetItemText((int)lParam2, pSortInfo->iIndex));

	return (i1 - i2);
}

void CdialogMain::OnHdnItemclickListFiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);

	if (phdr->iItem == 0)
		m_cntrlList_Files.SortItems(StringCompareProc, (DWORD_PTR)&m_cntrlList_Files);
	else
	{
		SORTINFO sortinfo;
		sortinfo.iIndex = phdr->iItem;
		sortinfo.pListCtrl = &m_cntrlList_Files;
		m_cntrlList_Files.SortItems(IntegerCompareProc, (DWORD_PTR)&sortinfo);
	}

	for (int iCount = 0; iCount < m_cntrlList_Files.GetItemCount(); iCount++)
		m_cntrlList_Files.SetItemData(iCount, iCount);

	*pResult = 0;
}

void CdialogMain::OnNMDblclkListFiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	POSITION pos = m_cntrlList_Files.GetFirstSelectedItemPosition();
	if (pos)
	{
		int iIndex = m_cntrlList_Files.GetNextSelectedItem(pos);
		CString strPath;
		m_cntrlList_Directories.GetText(0, strPath);
		strPath += _T("\\") + m_cntrlList_Files.GetItemText(iIndex, 0);
		ShellExecute(GetSafeHwnd(), _T("open"), strPath, NULL, NULL, SW_SHOW);
	}

	*pResult = 0;
}

void CdialogMain::OnLvnKeydownListFiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);

	CUIntArray array;

	if (pLVKeyDow->wVKey == VK_DELETE)
	{
		POSITION pos = m_cntrlList_Files.GetFirstSelectedItemPosition();
		while (pos)
		{
			int iIndex = m_cntrlList_Files.GetNextSelectedItem(pos);
			iFiles--;
			CString strBuf;
			strBuf = m_cntrlList_Files.GetItemText(iIndex, 1);
			iTotalFixMes -= atoi(strBuf);
			strBuf = m_cntrlList_Files.GetItemText(iIndex, 2);
			iTotalCode -= atoi(strBuf);
			strBuf = m_cntrlList_Files.GetItemText(iIndex, 3);
			iTotalComments -= atoi(strBuf);
			strBuf = m_cntrlList_Files.GetItemText(iIndex, 4);
			iTotalTotal -= atoi(strBuf);

			array.Add(iIndex);
		}
	}

	m_strTotals.Format(_T("Files: %i FIXMEs: %i Code: %i Comments: %i Total: %i"), iFiles, iTotalFixMes, iTotalCode, iTotalComments, iTotalTotal);
	UpdateData(FALSE);

	for (INT_PTR iCount = (array.GetCount() - 1); iCount >= 0; iCount--)
		m_cntrlList_Files.DeleteItem(array[iCount]);

	for (int iCount = 0; iCount < m_cntrlList_Files.GetItemCount(); iCount++)
		m_cntrlList_Files.SetItemData(iCount, iCount);

	*pResult = 0;
}
